%!TEX root=../thesis.tex

\section{Graph Wavelets review}
\label{sec:fundamentacao_weg}

    %\footnote{More information on classic Wavelets theory can be found at \cite{burrus1998introduction,mallat2008wavelet}.} 

Classic Wavelets theory was extended to graphs, allowing to perform localized analysis of graph functions. 
\citeonline{Shuman2013} classifies graph Wavelets methods into: \emph{node domain} and \emph{graph spectral} designs.

\subsection*{Node domain designs} \citeonline{Crovella2003} defined Wavelet like functions $\psi_{m,\n i}:\vset \rightarrow \rset$, which are localized on node $\n i$ and scale $m$, as dilations and translations of a mother function $\psi$.
The restriction $\sum_{\n i\in\vset} \psi_{m,\n i} = 0$ is imposed on such functions, so that the resulting Wavelets have zero mean.
Thus, $\psi_{m,\n i}$ is defined as: 

\[\psi_{m,i}(\n j) = \frac{\alpha_{\n i,k}}{|\partial \mathcal N (\n i, k)|}, \quad \forall \n j \in \partial  \mathcal N (\n i, k),\]
where 
%constants $\alpha_{\n i,\kappa}$ meet
$\sum_{k=0}^s \alpha_{\n i,k} = 0$ and $\partial \mathcal N (\n i, k)$ is the subset of nodes which are $k$ nodes away from $\n i$.

Constants  $\alpha_{\n i,k}$ are computed from a continuous function $\psi(\cdot)$, supported on $[0,1)$, by taking $a_{\n i,\kappa}$ to be the average of $\psi(\cdot)$  on the interval ${I_{m,k} = \left[ \frac{k}{m+1}, \frac{k+1}{m+1}\right]}$.
The localized functions $\psi_{m,\n i}$ provide a multi-scale vision of the graph function. However, they are not invertible, which is a desirable property in many signal  processing applications.
  
Variations of the lifting scheme, used in traditional wavelets theory, were proposed for graphs \cite{Narang2009,Wagner2006,Shen2010}.
In this approach, the node set is divided into two disjoint subsets $\vset = \vset_I \cup \vset_J$.
At each lifting step, nodes from $\vset_I$ use their own values and values from their neighbors in $\vset_J$ to \emph{predict} their coefficients.
Then, using this predicted values along with its own values, nodes from $\vset_J$ \emph{update} their coefficients.
The subset  $\vset_J$ is the input for the next lifting step.
\citeonline{Jansen2009} proposed an iterative lifting scheme computing one coefficient at a time.

\subsection*{Graph spectral domain designs} \citeonline{Coifman2006} introduced a method for building a set of orthonormal scaling functions and wavelets associated to them (\emph{diffusion Wavelets}). 
The scaling basis is constructed as an approximation of a given diffusion operator that models the graph topology at a specified scale.
For each scale, a wavelet function is built by finding the orthogonal complement to the corresponding scale space.
The orthogonalization process is done using the Gram-Schmidt procedure which is expensive and also obscures the relation between the diffusion operator and Wavelets functions.

\citeonline{Hammond2011} proposed to use kernel filters (dictionaries) on the graph spectral domain to define the Graph Wavelets Transform. They introduced the Spectral Graph Wavelets (SGW) based on dilations of a polynomial function.
Later, other dictionaries, kernel filters in the spectral domain, to 
perform the Wavelet Transform on graphs were proposed \cite{Narang2012,Leonardi2011,Leonardi2013,Shuman2015}.
\citeonline{Narang2012} proposed  two-channel filter banks on bipartite graphs. 
The resulting Wavelets functions are orthogonal and critically sampled allowing for perfect reconstruction. 
However, this transform is only possible for bipartite graphs.
\citeonline{Shuman2015} proposed Spectrum-Adapted Graph Wavelets (SAGW) which is a dictionary defined 
as warped versions of uniformly translated kernels.
SGW and SAGW are further discussed in \Cref{sec:gwave}. 
%

%Eles utilizaram a matriz Laplaciana não normalizada do grafo bipartido pelo fato de os autovalores da mesma serem $0=\eigvaln_1<...<\eigvaln_{\max}=2$. 
%Dessa forma, o espectro do grafo pode ser exatamente dividido em baixas e altas frequências.


\section{Spectral Graph Wavelet Transform}
\label{sec:gwave}

% The central idea of graph wavelet transform is to decompose a function $f$ in terms of basis functions 
%  $\psi_{m,i}$ that depend on a scale $m$ and a location $\n i$.
% %$f$ is projected onto spaces generated by the basis functions and 
% An interesting aspect of wavelets is that projecting the function $f$ onto spaces with different scales is equivalent 
% to band-pass filtering the function $f$, that is, each scale corresponds to 
% a specific band-pass filter. 

A dictionary $\{\hat{g}_{m}\}_{m=1,2,\ldots,M}$ is defined
as a set of graph spectral filters $\hat{g}_{m}:\Lambda\rightarrow\mathbb{R}$,
$m=1,2,\ldots,M$, where $M$ is the number of kernels in the dictionary. 
Recalling that the eigenvalues $\lambda_j$ correspond to frequencies in the graph Fourier domain,
we can define filters by properly handling the eigenvalues $\lambda_j$ according to scales $m$.
The Spectral Graph Wavelet Transform, from now on referred as \emph{Graph Wavelet Transform} (GWT), (Equation (\ref{eq:coeff_wave}))
relies on a dictionary of one scaling kernel $\{\hat{g}_{1}\}$ and $M-1$ wavelet kernels $\{\hat{g}_{m}\}_{m=2,\ldots,M}$
defined in the spectral domain.
Given
a signal $f$ and a dictionary $\{\hat{g}_{m}\}_{m=1,2,\ldots,M}$, 
the GWT $W_f:\{1,\ldots,M\}\times
V\rightarrow\mathbb{R}$ is defined as:
\begin{equation}
  W_{f}(m,\tau_j)=\sum_{\ell=1}^{n} \hat{g}_{m}(\lambda_{\ell})\widehat{f}(\lambda_{\ell})u_{\ell}(\tau_j),
  \label{eq:coeff_wave}
\end{equation}
which is the graph filtering operator defined in \Cref{sec:spec_filt}.

By varying $m$ while keeping $\tau_j$ fixed, we obtain $M$ coefficients associated to $\tau_j$: one
 scaling coefficient and $M-1$ wavelet
coefficients. Moreover, the product 
$\hat{g}_{m}(\lambda_{\ell})\widehat{f}(\lambda_{\ell})$, on the right of
Equation~\ref{eq:coeff_wave}, shows that each coefficient $W_{f}(m,\tau_j)$
is obtained by modulating $\widehat{f}(\lambda_{\ell})$ by the kernel
$\hat{g}_{m}(\lambda_{\ell})$.  The rationale behind \Cref{eq:coeff_wave} is that 
for large values of $m$, large scales, the filter $g$ stretches out favoring high 
frequency modes essential to good localization. 
Small values of $m$ (small scales) compress the function around low frequency modes to 
encode coarser description of a local neighborhood.

To illustrate this fact, consider the same signal $f_0$ used
in \Cref{chapter:gsp}, defined as a combination of
low and high frequency eigenvectors.
The heatmap on bottom of \Cref{fig:pg} depicts the wavelets
coefficients of all nodes, where each column is associated to a node and each row represents a
scale $m$. Rows on the heatmap are ordered from low to high frequencies and columns have the same order as in the path graph shown above. The coefficient corresponding to the first low frequency for node $n_{4}$ is larger than any other
coefficients, reflecting the fact that the signal in node $n_{4}$ is
smooth. In contrast, larger coefficients appear in high frequencies,
indicating that the signal oscillates more abruptly around node $n_{42}$.
While node $n_{31}$, where the signal is close to smooth and abrupt oscillations, 
has coefficients of low value in all scales.


\begin{figure}
  \centering
  \shadowimage[width=\textwidth]{figs/wavs/path_sgw.png}\\[.3cm]
  \caption[Spectral Graph Wavelet coefficients of nodes for a signal defined on a path graph.]{\textbf{Signal:} $f_0$ signal
    defined on a path graph with 64 nodes. Signal $f_0$ is a combination
    of low and high frequency signals. The height of the vertical blue lines and the color of the nodes correspond to the amplitude of the signal. 
    \textbf{SGW coefficients:} Wavelet coefficients of
    all nodes for signal $f_0$. Each column represents a node, while each row represents a scale
    of the wavelets coefficients from low (top of the matrix) to high (bottom of the matrix) frequencies. Coefficient values are encoded using color. The order of the columns is the same as the order of the nodes from the path graph shown above.
     \label{fig:pg}}
\end{figure}

Many ways to define dictionaries for the GWT have been proposed in the literature \cite{Leonardi2011,Leonardi2013,Shuman2015}.
The \emph{Spectral Graph Wavelets (SGW)}, proposed by \citeonline{Hammond2011}, are defined as a dictionary composed of a low-pass filter (scaling kernel) and dilations of a band-pass filter (wavelet kernels). 
In mathematical terms,
the wavelet kernels are defined using the mother kernel:
\begin{equation}
\fourier g(x)=\displaystyle\left\{\begin{array}{ll}
 x_1^{-\alpha}x^{\alpha} & \mbox{for } x < x_1\\
 p(x) & \mbox{for } x_1\leq x \leq x_2\\
 x_2^{\beta}x^{-\beta} & \mbox{for } x > x_2
 \end{array}\right.
\label{eq:wcoeff}
\end{equation}
where $\alpha, \beta, x_1, x_2$ are parameters of the filter that can be tuned
to change the behavior of $\fourier g$. 
Function $p(\cdot)$ is a cubic polynomial satisfying $p(x_1)=p(x_2)=1$, $p^{\prime}(x_1)=\alpha/x_1$,
and $p^{\prime}(x_2)=-\beta/x_2$.
The $M-1$ wavelet kernels are obtained by scaling the mother kernel: $\fourier g_{m}(\lambda_\ell)_{m=2,\ldots,M} = \fourier g(m\lambda_\ell)$.
The scales are logarithmically sampled between $m_{\min}=m_2,\ldots,m_M=m_{\max}$,
where $m_{\min}=x_2/\lambda_{\max}$, $\lambda_{\max}$ is the largest frequency in the spectrum, and $m_{\max}=20x_2/\lambda_{\max}$.
% In our implementation, we set all the parameters as 
% suggested in~\cite{Hammond2011}, $\alpha=\beta=2, x_1=1, x_2=2$. 

\begin{figure}
\centering
\includegraphics[width=\linewidth]{figs/wavs/filters_path_comet.png}
\caption[Filter design: Graph spectral filters for the SGW and SAGW dictionaries.]{Filter design: Graph spectral filters for the SGW and SAGW dictionaries.
  The SAGW filters adapt to regions with larger spectral density. The $x$ marks
  on the horizontal axis represent the graph Laplacian spectrum of a path graph (left) and a comet graph (rigth).}
\label{fig:filter_design}
\end{figure}


The scaling kernel is defined as $\fourier g_{1}(x)=\gamma \left(-\exp(\frac{x}{0.6 \lambda_{\min}})^4\right)$where the parameter $\gamma$ is chosen such that $\fourier g_{1}(0)$ is
equal to the maximum value of $g$.
%The provided formulation is based on the work by \cite{Hammond2011}, but we are presenting it using a more linear algebra notation to easy interpretation. 
Left column of \Cref{fig:filter_design} illustrates the $SGW$ with 6 distinct scales for the wavelet kernels and the scaling kernel, computed as described above. 

In the example in Figure~\ref{fig:pg} the wavelet coefficients were obtained using the SGW for a path graph. In this case
the graph defining the signal domain
is essentially the same as a discretization of the real line, that is,
the graph topology is fairly regular. Thus,
the strategy employed by SGW of evenly cover the spectral domain considering only $\lambda_{\max}$ 
will result in a dictionary that represents well the graph frequencies, as shown in left of \Cref{fig:filter_design}. 

However, in scenarios where the graph is
irregular the eigenvalues are not evenly distributed.
For instance, the $x$ marks on the horizontal axis on the plots on the right of Figure~\ref{fig:filter_design} represent the spectrum for a comet graph (like the one shown in \Cref{fig:cg}). 
Using the SGW will result in a dictionary with unequal number of eigenvalues in each frequency band (top-right of \Cref{fig:filter_design}).
\citeonline{Shuman2015} addressed this problem by proposing the \emph{Spectrum-Adapted
Graph Wavelets} (SAGW).  
The bottom-right of Figure~\ref{fig:filter_design} shows the SAGW dictionary defined in the
spectral domain of a comet graph.
As one can clearly see, when eigenvalues are not evenly distributed in the
spectral domain, as is the case of the comet graph, the SAGW dictionary better
fits the frequency bands. 

The SAGW wavelet kernels are defined as:  $\fourier g_{m}(\lambda_\ell)_{m=2,\ldots,M} = \fourier g(\omega(\lambda_\ell))$,
where $\omega$ is a warping function that approximates the cumulative spectral density function.
And the scaling kernel:  $\fourier g_{1}(x)= \sqrt{Ra^2_0 + R/2 \sum_{k=1}^K - \sum_{m=2}^M|\fourier{g_m}(\ell)|^2}$, 
where $R$, $M$ and $K$ are any integers such that $2<R\leq M$ and $K < R/2$, and $a_k \in \rset$ are coefficients satisfying $\sum_{k=0}^K (-1)^k a_k = 0$.
The SAGW dictionary forms a tight frame
that allows interpreting the squared magnitudes of the coefficients as an
energy density function~\cite{Shuman2015}, making the understanding
of wavelets coefficients an easier task.




% \section{Understanding the Interplay among Spectrum, Topology, and Wavelet Coefficients}
% \label{sec:res}
% In the previous section we showed how the behavior of a signal affects
% the graph Fourier and graph wavelet coefficients.  However, in the
% examples in Figure~\ref{fig:pg} the graph defining the signal domains
% is essentially the same as a discretization of the real line, that is,
% the graph topology is fairly regular. , as we discuss in the
% following.

\begin{figure}
  \centering
  \shadowimage[width=0.98\textwidth]{figs/wavs/comet_sgw_sgaw.png}\\[.3cm]
  \caption[Spectral Graph Wavelet and Spectral Adapted Graph Wavelet coefficients of nodes for a signal defined on a cometh graph.]{\textbf{Top:} Second largest graph Laplacian eigenvector ($u_{62}$) defined on a
  comet graph with 64 nodes. The color associated to the graph nodes encodes the
  signal. \textbf{SGW coefficients:} Spectral Graph Wavelet coefficients of
    all nodes for signal $u_{62}$. Each column represents a node, while each row represents a scale
    of the wavelets coefficients from low (top of the matrix) to high frequencies (bottom of the matrix). Coefficient values are encoded using color. \textbf{SAGW coefficients:} Spectral Adapted Graph Wavelet coefficients of
    all nodes for signal $u_{62}$. \label{fig:cg}}
\end{figure}

% \paragraph*{Comet experiment.} A \emph{comet graph} is formed by combining
% a path graph and a star graph, the latter centered in one of the extremities
% of the path graph, as illustrated at the top of Figure~\ref{fig:cg}. 
% The eigenvalues of the graph Laplacian of a comet graph present a peculiar
% distribution, as the difference between the two largest eigenvalues is much
% larger than the difference between the other eigenvalues (Figure~\ref{fig:cg}
% bottom left).  Although the second largest eigenvalue is distant from the
% largest eigenvalue, it corresponds to the second highest frequency in the
% spectrum of the comet graph.


In order to further illustrate this point, we created a comet graph with 64
nodes with the star extremity containing $30$ nodes.  The signal is defined
as the second largest graph Laplacian eigenvector (Figure~\ref{fig:cg} top).
The
wavelet coefficients, computed via SGW and SAGW, are
also illustrated at the bottom of Figure~\ref{fig:cg}.  The SGW dictionary of node 
$n_{47}$
led to wavelet coefficients with dominant frequencies in the central scales,
not properly characterizing the high frequency nature of the signal under
analysis. In contrast, SAGW dictionary resulted in wavelet coefficients with
larger intensity in the scales related to high frequencies, better capturing
the pattern of variation of the signal.



% \paragraph*{Minnesota experiment.}
% The synthetic examples above showed how the topology of a graph can affect the
% wavelet coefficients. Lets analyze now how patterns in the signal are captured
% by wavelet coefficients.

% Consider the Minnesota road graph~\cite{Gleich2015} depicted in
% Figure~\ref{fig:mg}. We divide the graph into three different regions $R_1$,
% $R_2$, and $R_3$, colored as blue, green, and red in the cluster panel of
% Figure~\ref{fig:mg}.  A signal with different dominant frequency band is
% assigned to each region, resulting in a global signal defined as:

% \begin{equation}
%   f:=\sum_{j=1}^{3} f_j/||f_j||_{\infty} \quad \mbox{where}
% \end{equation}

% \begin{equation}
%   f_j(\tau_i)=\left\{\begin{array}{ll}
%   \displaystyle\sum_{\ell\in I_j} u_{\ell}(\tau_i) & \mbox{if } \tau_i \in R_j \\
%   \hfil 0 & \mbox{otherwise}\end{array}\right.
% \end{equation}

% \noindent where $I_j$ are the indices of the eigenvalues lying in
% the intervals $[a_j,b_j]$ given by $[0.0,0.08]$, $[2.0,2.5]$, and
% $[5.0,7.0]$.  The ranges of the intervals were chosen according to
% the distribution of the eigenvalues as illustrated in the eigenvalues
% panel of Figure~\ref{fig:mg}. Therefore, region $R_1$ (blue) has
% a low frequency signal, since it is the summation of eigenvectors
% corresponding to eigenvalues in the low frequency region of the
% spectrum.  Similarly, the signal in $R_2$ (green) and $R_3$ (red)
% correspond to the summation of eigenvectors associated with high
% and median frequency eigenvalues, respectively.  The signal panel
% of Figure~\ref{fig:mg} shows the signal $f$ as defined above. The
% node coefficients panel of Figure~\ref{fig:mg} illustrates
% representative wavelet coefficients for each region computed using
% the SAGW dictionary. 
% Notice that the behavior of the coefficients corresponds to exactly what we expect.
% However, the coefficients
% corresponding to representative nodes are observed mainly in the
% middle of each region. Nodes close to the boundary between regions
% tend to have a more mixed behavior, as illustrated in the node
% coefficients panel of Figure~\ref{fig:mg}.

% \begin{figure*}[t]
%   \centering
%   \includegraphics[width=0.98\textwidth]{figs/wavs/cise/minnesota.pdf}  
%   \caption{\textbf{Left:} The Minnesota road graph~\cite{Gleich2015}
%   divided into three different regions and the signal defined on the
%   Minnesota road graph. The signal is formed so each region has a dominant
%   frequency interval, which are highlighted on graph Laplacian eigenvalues bellow.
%   \textbf{Right:} Wavelet coefficients of representative nodes in the
%   regions on the left (dot colors) and one node close to the boundary
%   between regions (pink). The bar plots represent node feature vectors,
%   where the coefficients are ordered from smaller to higher frequencies.
%   The GWT was produced using the SAGW dictionary. Source: \cite{dal2017wavelet}. \label{fig:mg}}
% \end{figure*}



% \section{Time-Varying Data}
% The discussion above assumes a static signal defined on the nodes of the
% graph. However, in many applications data varies with time, resulting in
% a time series associated to each node~\cite{Valdivia2015}. One of
% the possible options to create a graph representing time-varying data is
% using the Cartesian product of graphs.

% Given two graphs $G=(V_{G},E_{G})$ and $H=(V_{H},E_{H})$, the Cartesian
% product between them is a graph $G\times H$ with node set
% $V_G\times V_H=\{\tau_i\iota_j\suchthat \tau_i\in V_G, \iota_j\in V_H\}$
% and edges connecting nodes $\tau_i\iota_j$ and $\tau_k\iota_l$ if only if
% $\tau_i=\tau_k$ and $\iota_j$ is adjacent to $\iota_l$ in $H$, or
% $\iota_j=\iota_l$ and $\tau_i$ is adjacent to $\tau_k$ in $G$. If $H$ is
% a path graph, the Cartesian product $G\times H$ graph, as illustrated in
% Figure~\ref{fig:gxh}, corresponds to ``stacked'' copies of $G$ with edges
% connecting corresponding nodes in adjacent copies of $G$. Each copy of
% $G$ is interpreted as time slices of the temporal data, enabling the use
% of GFT and GWT on $G\times H$ to analyze time varying data.

% \begin{figure}
%   \centering
%   \includegraphics[width=0.375\textwidth]{figs/wavs/cise/networkgraph.pdf}  
%   \caption{A spatio-temporal data set modeled by Cartesian product $G\times H$
%   of graphs spatial $G$ and temporal $H$. \label{fig:gxh}}
% \end{figure}

% \begin{figure}
%   \centering
%   \includegraphics[width=0.98\textwidth]{figs/wavs/cise/spatio-temporal.pdf}  
%   \caption{\textbf{Left:} Graphs spatial $G$ and temporal $H$. \textbf{Center:}
%   Wavelet coefficients of the node $\tau_a\iota_{10}$ for the functions $f_i$,
%   $i=1,2,3,4$. \textbf{Right:} Wavelet coefficients of the node $\tau_a\iota_{10}$
%   for the functions $f_3$ after edges removal. The GWT was produced using the SAGW
%   dictionary. \label{fig:st}}
% \end{figure}

% In the Cartesian graph, the coefficients derived from GFT and GWT
% capture spatial and temporal behavior of the signal, making their
% interpretation more intricate than in the static case. In order to
% gain intuition, we design a Cartesian graph $G\times H$ where $G$
% is as depicted in the leftmost panel in Figure~\ref{fig:st} and
% $H$ is a path graph with twenty nodes; $G\times H$ comprises twenty
% time slices of a time-varying signal defined on its nodes. We also
% craft four different time-varying signals on $G\times H$, denoted
% as $f_i,\, i=1,\ldots,4$. The signal $f_1$ is defined with a spike
% (value equal 1) in the node $\tau_a\iota_{10}$ of $G\times H$,
% vanishing in the remaining nodes. The nodes $\tau_a$ and $\iota_{10}$
% are enhanced in the leftmost panel in Figure~\ref{fig:st}. In
% other words, $f_1$ has a spike in the node $\tau_a$ in time slice
% $\iota_{10}$.  The signal $f_2$ is defined as a ``spatial'' Gaussian
% centered in $\tau_a\iota_{10}$, assigning values for nodes in the
% neighborhood of $\tau_a$ in time slice $10$ and zero in other time
% slices.  The signal $f_3$ is defined as a ``temporal'' Gaussian
% centered in $\tau_a\iota_{10}$, assigning values for nodes
% $\tau_a\iota_j,\, j=1,\ldots,20$ and zero elsewhere.  Finally, $f_4$
% is the combination of a Gaussian over time centered at
% $\tau_a\iota_{10}$ and Gaussians in all time slices with spikes in
% $\tau_a\iota_j,\, j=1,\ldots,20$.

% The bar plots in the center panel of Figure~\ref{fig:st} show the
% wavelet coefficients associated to the node $\tau_a\iota_{10}$. The
% coefficients correctly reflect the behavior of the functions in the
% selected node. In the top left bar plot, corresponding to $f_1$,
% there is a concentration of larger coefficients in high scales,
% indicating that $f_1$ has a high frequency in $\tau_a\iota_{10}$. 
% The smoothness of $f_2$ and $f_4$ in $\tau_a\iota_{10}$ are also
% evident in the bar plots on the bottom row. The bar plot on the top
% right, which reflects the behavior of $f_3$ around $\tau_a\iota_{10}$,
% does not clearly depict the temporal smoothness of $f_3$, as the
% amplitude of the coefficients of $f_3$ in $\tau_a\iota_{10}$ are
% similar to those of $f_1$.  The reason for GWT not properly capturing
% the temporal smoothness of $f_3$ in $\tau_a\iota_{10}$ is the topology
% $G\times H$, which contains many more spatial than temporal edges
% around $\tau_a\iota_{10}$.  In fact, there are only two temporal
% edges with ends in $\tau_a\iota_{10}$.  Therefore, the spatial
% distribution of $f_3$ around $\tau_a\iota_{10}$ impacts more the
% wavelet coefficients than its temporal distribution. This fact
% becomes obvious when we remove some spatial edges from the neighborhood
% of $\tau_a\iota_{10}$, triggering a shift of the coefficients to
% low frequency scales, as illustrated in the rightmost panel of
% Figure~\ref{fig:st}.



% \paragraph{Manhattan taxi pick-ups.}
% Discussion above raises the question whether it is worth using the
% Cartesian product graph. Would results be similar if GWT analysis
% were applied in each time slice independently? We answer these
% questions through a real application scenario involving taxi
% pick-ups in downtown Manhattan. 

% The left panel of Figure~\ref{fig:manhattan_signal} depicts the
% street map of downtown Manhattan with corners colored by the number
% of taxi pick-ups in August 12, 2013, 07:30 to 08:00. The left panel
% of Figure~\ref{fig:manhattan_signal} also shows the number of the
% taxi pick-ups at the corner of 8th Avenue with 41st Street at
% 07:00-07:30, 07:30-08:00, and 08:00-08:30 consecutive time slices 
% ($t_{i-1}$, $t_i$, $t_{i+1}$). There are large spatial variations in
% the number of pick-ups on the corners of 41st Street near 8th Avenue
% in all time slices.  By analyzing the (spatial) wavelet coefficients
% at the node 8th-41st at 07:30 to 08:00 time slice (leftmost column
% in the right panel of Figure~\ref{fig:manhattan_signal}) there is a
% predominance of mid and high frequency. However, the number of taxi
% pick-ups does not vary drastically among the adjacent time slices.
% Therefore, considering the temporal variation, the signal is smooth.
% Computing the (time-varying) wavelet coefficients at the node
% 8th-41st at 07:30 to 08:00 time slice, but considering now the
% Cartesian product graph, that is, the three time slices are connected
% by temporal edges, we obtain the distribution of coefficients shown
% on the leftmost column in the right panel of
% Figure~\ref{fig:manhattan_signal}. The coefficients tend to concentrate
% in the low frequency scales, showing that when the spatial and temporal
% information are considered simultaneously, the signal tends to be of
% low frequency. Center and rightmost columns of
% Figure~\ref{fig:manhattan_signal} correspond to the same analysis but
% considering the two other corners, where a shift of the coefficients to
% low frequency also take place when temporal edges are considered.

% \begin{figure}
%   \centering
%   \includegraphics[width=0.98\textwidth]{figs/wavs/cise/manhattan.pdf}
%   \caption{\textbf{Left:} Taxi pick-ups in downtown Manhattan on August 12,
%   2013, 07:30 to 08:00 (top) and at the corner of 8th Avenue with 41st Street
%   at 07:00-07:30, 07:30-08:00, and 08:00-08:30 consecutive time slices
%   ($t_{i-1}$, $t_i$, $t_{i+1}$)(bottom). \textbf{Right:} Spatial (top) and
%   spatio-temporal (bottom) wavelet coefficients of the nodes on the corner
%   of 8th Avenue with 41st Street (left), Church Street with Duane Street (center),
%   and 6th Avenue with 53rd Street (right) corresponding to August 12, 2013,
%   07:30 to 08:00. The GWT was produced using the SAGW dictionary.
%   \label{fig:manhattan_signal}}
% \end{figure}

% From the provided experiments, the Cartesian product graph is more
% suitable to handle spatio-temporal data via GFT and GWT, better
% capturing properties of the signal, whether they are spatial or
% temporal.

